#!/bin/sh

. ./targets.sh

tool="gcc"
operation="build"
. ../config.sh

# common options.
opt="--prefix=$install_dir"
opt="$opt --disable-werror --disable-nls --disable-threads --disable-shared"

# for current gcc (gcc-4.x.x)
# use LD_RUN_PATH instead of LD_LIBRARY_PATH to avoid runtime error.
# (if use LD_LIBRARY_PATH, fail to open shared libraries)
#LD_RUN_PATH=$install_dir/gmp/lib:$install_dir/mpfr/lib:$install_dir/mpc/lib
#export LD_RUN_PATH
#opt="$opt --with-gmp=$install_dir/gmp"
#opt="$opt --with-mpfr=$install_dir/mpfr"
#opt="$opt --with-mpc=$install_dir/mpc"
#opt="$opt --disable-libssp"
# unneed
##opt="$opt --without-headers"
##opt="$opt --disable-hosted-stdcxx"
##opt="$opt --with-gnu-as --with-gnu-ld --with-gnu-ar"

opt_cpp="$opt --enable-languages=c,c++"
opt_c="$opt --enable-languages=c"

# no newlib

if [ -L ../$toolchain_dir/$gcc/newlib ]; then
    rm -f ../$toolchain_dir/$gcc/newlib
fi
if [ -L ../$toolchain_dir/$gcc/libgloss ]; then
    rm -f ../$toolchain_dir/$gcc/libgloss
fi

for target in $targets; do
    t=`echo $target | tr - _`
    opt_add=`eval echo '$opt_'$t`
    option="$opt_c $opt_add"

    mkdir -p $target
    cd $target
    ../../$toolchain_dir/$gcc/configure --target=$target $option
    $make $makeopt
    cd ..
done

# for newlib

opt_cpp="$opt_cpp --with-newlib"
opt_c="$opt_c --with-newlib"

if [ ! -L ../$toolchain_dir/$gcc/newlib ]; then
    ln -s ../$newlib/newlib ../$toolchain_dir/$gcc/newlib
fi
if [ ! -L ../$toolchain_dir/$gcc/libgloss ]; then
    ln -s ../$newlib/libgloss ../$toolchain_dir/$gcc/libgloss
fi

for target in $targets_cpp; do
    t=`echo $target | tr - _`
    opt_add=`eval echo '$opt_'$t`
    option="$opt_cpp $opt_add"

    mkdir -p $target
    cd $target
    ../../$toolchain_dir/$gcc/configure --target=$target $option
    $make $makeopt
    cd ..
done

for target in $targets_c; do
    t=`echo $target | tr - _`
    opt_add=`eval echo '$opt_'$t`
    option="$opt_c $opt_add"

    mkdir -p $target
    cd $target
    ../../$toolchain_dir/$gcc/configure --target=$target $option
    $make $makeopt
    cd ..
done
